module Main where
 
paddle :: Double -> G.Rectangle2DDouble
paddle xpos = G.rectangle (xpos - 25) 200 50 10
 
pball :: Double -> GUI () (Maybe ())
pball vel
  = ((loop
	((arr id &&& (asnd >>> asnd >>> afst >>> integral)) >>>
	   (let xpos = 30 + xi in
	      (afst >>>
		 (arr id &&& (asnd >>> asnd >>> asnd >>> afst >>> integral)) >>>
		   (let ypos = 30 + yi
			ballS = ell (xpos - 12.5) (ypos - 12.5) 25 25
			ballPicS = G.shapePic ballS `G.withColor` G.yellow
		      in
		      (afst >>>
			 (arr id &&&
			    (aunit >>> arr (\ () -> (xpos > 175) || (xpos < 30)) >>> implies))
			   >>>
			   (arr id &&&
			      (afst >>>
				 asnd >>>
				   afst >>>
				     arr (\ hitPaddle -> (ypos < 30) || hitPaddle) >>> implies))
			     >>>
			     (let hitPaddle = intersects ballS paddleS in
				((arr id &&&
				    (afst >>>
				       asnd >>>
					 arr (\ xbounce -> ebind negate xbounce) >>>
					   (stepAccum vel)))
				   >>>
				   (arr id &&&
				      (afst >>>
					 asnd >>>
					   arr (\ ybounce -> ebind negate ybounce) >>>
					     (stepAccum vel)))
				     >>>
				     (arr id &&&
					(afst >>>
					   afst >>>
					     afst >>>
					       afst >>>
						 afst >>> arr (\ (inpS, _) -> inpS) >>> mouseB))
				       >>>
				       (let paddleS = paddle (G.pointX mpos)
					    paddlePicS = G.shapePic paddleS `G.withColor` G.green
					  in
					  (afst >>>
					     (arr id &&&
						(aunit >>> arr (\ () -> ypos > 200) >>> implies))
					       >>>
					       (let gamePic
						      = G.box
							  (walls `G.over` paddlePicS `G.over`
							     ballPicS)
							  gameBox
						  in
						  ((asnd &&& (aunit >>> arr (\ () -> gamePic))) &&&
						     ((aunit >>> arr (\ () -> hitPaddle)) &&&
							((afst >>> afst >>> asnd) &&&
							   ((afst >>> asnd) &&&
							      (aunit >>>
								 arr
								   (\ () -> paddleS)))))))))))))))))
       >>> combine >>> arr (\ (gameOver, gamePic) -> (gamePic, gameOver)))
 
pball2 :: Double -> GUI () (Maybe ())
pball2 speed
  = (loop
       ((arr id &&& (asnd >>> asnd >>> afst >>> integral)) >>>
	  (let pos = 30 + p
	       ballS = ell (pos - 12.5) (point 25 25)
	       ballPicS = G.shapePic ballS `G.withColor` G.yellow
	     in
	     (afst >>>
		(arr id &&&
		   (aunit >>>
		      arr (\ () -> (xc pos > 175) || (xc pos < 30)) >>> implies))
		  >>>
		  (arr id &&&
		     (afst >>>
			asnd >>>
			  afst >>>
			    arr (\ hitPaddle -> (yc pos < 30) || hitPaddle) >>> implies))
		    >>>
		    (arr id &&& (aunit >>> arr (\ () -> yc pos > 200) >>> implies)) >>>
		      (arr id &&&
			 (afst >>>
			    ((afst >>> asnd >>> arr (\ xbounce -> - xbounce)) &&&
			       (asnd >>> arr (\ ybounce -> - ybounce)))
			      >>> point))
			>>>
			(let hitPaddle = intersects ballS paddleS in
			   ((arr id &&& (asnd >>> (stepAccum speed))) >>>
			      (arr id &&&
				 (afst >>>
				    afst >>>
				      afst >>>
					afst >>> afst >>> afst >>> arr (\ () -> ()) >>> mouseB))
				>>>
				(let paddleS = paddle (G.pointX mpos)
				     paddlePicS = G.shapePic paddleS `G.withColor` G.green
				   in
				   (afst >>>
				      (let gamePic
					     = G.box (walls `G.over` paddlePicS `G.over` ballPicS)
						 gameBox
					 in
					 ((arr id &&&
					     (afst >>>
						afst >>>
						  afst >>>
						    afst >>>
						      afst >>>
							afst >>>
							  arr (\ () -> ()) >>> (render gamePic)))
					    >>>
					    afst >>>
					      ((afst >>> afst >>> asnd) &&&
						 ((aunit >>> arr (\ () -> hitPaddle)) &&&
						    (asnd &&&
						       (aunit >>>
							  arr (\ () -> paddleS)))))))))))))))
