module Main where
import ProdArrows
import ProdArrowInstances
add f g = ((f &&& g) >>> combine >>> arr (\ (x, y) -> x + y))
a f = ((asnd &&& (afst >>> arr (\ x -> x + 1))) >>> app)
 
mdiagram ::
	 (Monad m) => (a -> m c) -> ((c, b) -> m d) -> (a, b) -> m (c, d)
mdiagram f g
  = \ (a, b) ->
      do c <- f a
	 d <- g (c, b)
	 return (c, d)
 
test ::
     (ProdArrow ac prod) =>
       ac a c -> ac (prod c b) d -> ac (prod a b) (prod c d)
test f g
  = ((arr id &&& (afst >>> f)) >>>
       (asnd &&& ((asnd &&& (afst >>> asnd)) >>> g)))
